-- scope stuff
qualityoflife = qualityoflife or {};
local q = qualityoflife;

q.modules = q.modules or {};
q.modules["QoL_ClassicThreat-TBC"] = q.modules["QoL_ClassicThreat-TBC"] or {};
local c = q.modules["QoL_ClassicThreat-TBC"];
c.name = "QoL_ClassicThreat-TBC";
c.version = 2; -- check for toc
c.minCoreVersion = 3;

local threatStatusColors = {
	[0] = { 0.69, 0.69, 0.69 };
	[1] = { 1, 1, 0.47 };
	[2] = { 1, 0.6, 0 };
	[3] = { 1, 0, 0 };
};

-- init
local function UpdateAddon()
	if not QOL_OPTIONS[c.name][q.META_LASTVERSION] or QOL_OPTIONS[c.name][q.META_LASTVERSION] < c.version then
		-- updates here

		QOL_OPTIONS[c.name][q.META_LASTVERSION] = c.version;
	end
	return true;
end

function c:Init()
	if q.initFinished and not c.initFinished and not c.initFailed then
		QOL_OPTIONS = QOL_OPTIONS or {};
		QOL_OPTIONS[c.name] = QOL_OPTIONS[c.name] or {};

		if q.version >= c.minCoreVersion then
			if UpdateAddon() and c:InitOptions() then

				QOL_OPTIONS[c.name]["version"] = c.version;

				c.initFinished = true;
				c:Println(q:GetText("Module loaded."));
				return true;
			end
		else
			c:Println(q:GetText("Error while initialization: QoL Core is outdated (version %s)! Minimum required version: %s", q.version, c.minCoreVersion));
			c:Println(q:GetText("Maybe another of your QoL addon comes with an older version. Please use the latest QoL_Core folder or download the latest version from CurseForge."));
		end
		c.initFailed = true;
	end
end

local targetThreatFrame;
local function GetTargetThreatFrame()
	if not targetThreatFrame then
		targetThreatFrame = CreateFrame("Frame", "TargetThreatFrame", TargetFrame, BackdropTemplateMixin and "BackdropTemplate");
		targetThreatFrame:SetPoint("TOPLEFT", TargetFrame ,"TOPLEFT", 2, -2);
		targetThreatFrame:SetFrameStrata("BACKGROUND");
		targetThreatFrame:SetSize(155, 36);

		targetThreatFrame.text = targetThreatFrame:CreateFontString("TargetThreatFrameFontString", "ARTWORK", "GameFontNormal");
		targetThreatFrame.text:SetTextColor(1, 1, 1, 1);
		targetThreatFrame.text:SetPoint("TOPLEFT", targetThreatFrame ,"TOPLEFT", 0, -7);
		targetThreatFrame.text:SetPoint("TOPRIGHT", targetThreatFrame ,"TOPRIGHT", 0, -7);

		targetThreatFrame.background = targetThreatFrame:CreateTexture(nil, "BACKGROUND");
		targetThreatFrame.background:SetTexture("Interface\\TargetingFrame\\UI-StatusBar");
		targetThreatFrame.background:SetPoint("TOP", 0 , -3);
		targetThreatFrame.background:SetSize(152, 16);

		targetThreatFrame.glow = targetThreatFrame:CreateTexture(nil, "BACKGROUND");
		targetThreatFrame.glow:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame-Flash");
		targetThreatFrame.glow:SetTexCoord(0, 0.955, 0, 0.755);
		targetThreatFrame.glow:SetPoint("TOPLEFT", -24, 0);
		targetThreatFrame.glow:SetSize(242, 93);
		targetThreatFrame.glow:Hide();

		targetThreatFrame:SetBackdrop({
			edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
			tile = true, tileSize = 16, edgeSize = 16,
			insets = { left = 8, right = 8, top = 8, bottom = 8 }});
	end
	return targetThreatFrame;
end

local playerThreatFrame;
local function GetPlayerThreatFrame()
	if not playerThreatFrame then
		playerThreatFrame = CreateFrame("Frame", "PlayerThreatFrame", TargetFrame, BackdropTemplateMixin and "BackdropTemplate");
		playerThreatFrame:SetPoint("TOPLEFT", TargetFrame ,"TOPLEFT", 2, -2);
		playerThreatFrame:SetFrameStrata("BACKGROUND");
		playerThreatFrame:SetSize(155, 36);

		playerThreatFrame.text = playerThreatFrame:CreateFontString("PlayerThreatFrameFontString", "ARTWORK", "GameFontNormal");
		playerThreatFrame.text:SetTextColor(1, 1, 1, 1);
		playerThreatFrame.text:SetPoint("TOPLEFT", playerThreatFrame ,"TOPLEFT", 0, -7);
		playerThreatFrame.text:SetPoint("TOPRIGHT", playerThreatFrame ,"TOPRIGHT", 0, -7);

		playerThreatFrame.background = playerThreatFrame:CreateTexture(nil, "BACKGROUND");
		playerThreatFrame.background:SetTexture("Interface\\TargetingFrame\\UI-StatusBar");
		playerThreatFrame.background:SetPoint("TOP", 0 , -3);
		playerThreatFrame.background:SetSize(152, 16);

		playerThreatFrame.glow = playerThreatFrame:CreateTexture(nil, "BACKGROUND");
		playerThreatFrame.glow:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame-Flash");
		playerThreatFrame.glow:SetTexCoord(0, 0.955, 0, 0.755);
		playerThreatFrame.glow:SetPoint("TOPLEFT", -24, 0);
		playerThreatFrame.glow:SetSize(242, 93);
		playerThreatFrame.glow:Hide();

		playerThreatFrame:SetBackdrop({
			edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
			tile = true, tileSize = 16, edgeSize = 16,
			insets = { left = 8, right = 8, top = 8, bottom = 8 }});
	end
	return playerThreatFrame;
end

local function ShowTargetThreat()
	if TargetFrame:IsVisible() then
		local targetThreatFrame = GetTargetThreatFrame();
		local isTanking, status, threatpct, rawthreatpct, threatvalue = UnitDetailedThreatSituation("player", "target");

		if status and rawthreatpct then
			if isTanking then
				-- show percentages above 100 if tanking
				rawthreatpct = UnitThreatPercentageOfLead("player", "target");
			end

			if rawthreatpct > 0 then
				targetThreatFrame.text:SetText(q:Round(rawthreatpct, 0) .. "%");
				targetThreatFrame:Show();

				if (status > 0) then
					targetThreatFrame.background:SetVertexColor(unpack(threatStatusColors[status]));
					targetThreatFrame.background:Show();
					targetThreatFrame.glow:SetVertexColor(unpack(threatStatusColors[status]));
					targetThreatFrame.glow:Show();
				else
					targetThreatFrame.background:Hide();
					targetThreatFrame.glow:Hide();
				end
				return;
			end
		end

		if targetThreatFrame:IsVisible() then
			targetThreatFrame:Hide();
		end
	end
end

local frames = {};
local function GetPartyFrame(partyId)
	local unitId = "Party" .. partyId;
	if not frames[unitId] then
		frames[unitId] = CreateFrame("Frame", "PartyThreatFrame_" .. partyId, _G["PartyMemberFrame" .. partyId], BackdropTemplateMixin and "BackdropTemplate");
		frames[unitId]:SetPoint("TOPLEFT", _G["PartyMemberFrame" .. partyId], "TOPRIGHT", -14, -10);
		frames[unitId]:SetSize(42, 21);

		frames[unitId].background = frames[unitId]:CreateTexture(nil, "BACKGROUND");
		frames[unitId].background:SetTexture("Interface\\TargetingFrame\\UI-StatusBar");
		frames[unitId].background:SetPoint("TOPLEFT", 2 , -2);
		frames[unitId].background:SetPoint("BOTTOMRIGHT", -2 , 2);

		frames[unitId].text = frames[unitId]:CreateFontString("PartyMemberFrame" .. partyId .. "FontString", "ARTWORK", "GameFontNormalSmall");
		frames[unitId].text:SetTextColor(1, 1, 1, 1);
		frames[unitId].text:SetPoint("TOPLEFT", frames[unitId], "TOPLEFT", 2, 0);
		frames[unitId].text:SetPoint("BOTTOMRIGHT", frames[unitId], "BOTTOMRIGHT", 0, 0);

		frames[unitId]:SetBackdrop({
			edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
			tile = true, tileSize = 10, edgeSize = 10,
			insets = { left = 4, right = 4, top = 4, bottom = 4 }});
	end
	return frames[unitId];
end

local threatCache = {};
local function ShowPartyThreat(playerPartyId)
	local unitId = "party" .. playerPartyId;
	local frame = GetPartyFrame(playerPartyId);

	for playerPartyId, playerName in ipairs(q:GetPartyMembers()) do
		local partyUnitId = "party" .. playerPartyId;
		local targetUnitIds = {
			partyUnitId .. "target",
			partyUnitId .. "targettargettarget"
		};

		for _, targetUnitId in ipairs(targetUnitIds) do
			if not UnitIsFriend(unitId, targetUnitId) then
				local guid = UnitGUID(targetUnitId);

				if guid then
					local isTanking, status, threatpct, rawthreatpct, threatvalue = UnitDetailedThreatSituation(unitId, targetUnitId);
					if status then
						if isTanking then
							-- show percentages above 100 if tanking
							local percent = UnitThreatPercentageOfLead(unitId, targetUnitId);
							if percent then
								rawthreatpct = percent;
							end
						end

						if rawthreatpct then
							if not threatCache[unitId] then
								threatCache[unitId] = {};
							end
							if not threatCache[unitId][guid] then
								threatCache[unitId][guid] = {};
							end
							threatCache[unitId][guid].threat = rawthreatpct;
							threatCache[unitId][guid].status = status;
						end
					end
				end
			end
		end
	end

	local highestStatus, highestThreatPct;
	if threatCache[unitId] then
		for enemyUnitId, threatInfo in pairs(threatCache[unitId]) do
			if not highestStatus or threatInfo.status > highestStatus then
				highestStatus = threatInfo.status;
			end
			if not highestThreatPct or threatInfo.threat > highestThreatPct then
				highestThreatPct = threatInfo.threat;
			end
		end
	end

	if highestStatus and highestThreatPct then
		frame.text:SetText(q:Round(highestThreatPct, 0) .. "%");
		if highestStatus > 0 then
			frame.background:SetVertexColor(unpack(threatStatusColors[highestStatus]));
			frame.background:Show();
		else
			frame.background:Hide();
		end
		frame:Show();
	elseif frame:IsVisible() then
		frame:Hide();
	end
end

local function OnCombatEvent(event, ...)
	local timestamp, subevent, _, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = ...;
	if subevent == "UNIT_DIED" and threatCache then
		-- remove enemy from cache
		for unitId, enemyUnitIds in pairs(threatCache) do
			threatCache[unitId][destGUID] = nil;
		end
	end

	-- own threat (detailed)
	--ShowPlayerThreat();
	ShowTargetThreat();
end

local function UpdateThreat()
	-- own threat (detailed)
	ShowTargetThreat();

	-- party / raid threat
	if IsInRaid() then
		-- in raid
		for playerRaidId, playerName in ipairs(q:GetRaidMembers()[0]) do
			--ShowRaidThreat(playerRaidId);
		end
	elseif IsInGroup() then
		-- in party
		for playerPartyId, playerName in pairs(q:GetPartyMembers()) do
			ShowPartyThreat(playerPartyId);
		end
	end
end

local function LeaveCombat()
	threatCache = {};
	GetTargetThreatFrame():Hide();
	for unitId, frame in pairs(frames) do
		frame:Hide();
	end
end

local eventFrame;
local function HookEvents()
	if not eventFrame then
		eventFrame = q:GetEventFrame();
		eventFrame:RegisterEvent("UNIT_THREAT_LIST_UPDATE");
		eventFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
		eventFrame:RegisterEvent("PLAYER_REGEN_ENABLED");
		eventFrame:HookScript("OnEvent", function(self, event, arg1, arg2, arg3, arg4)
			if event then
				if event == "ADDON_LOADED" and arg1 == c.name then
					c:Init();
				elseif event == "PLAYER_REGEN_ENABLED" then
					LeaveCombat();
				elseif c.initFinished then
					if event == "COMBAT_LOG_EVENT_UNFILTERED" then
						OnCombatEvent(event, CombatLogGetCurrentEventInfo());
					elseif event == "UNIT_THREAT_LIST_UPDATE" then
						UpdateThreat();
					end
				end
			end
		end);
	end
end
HookEvents();